'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = ssrComponentWithInitialProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _server = require('react-dom/server');

var _server2 = _interopRequireDefault(_server);

var _withContext = require('@s-ui/hoc/lib/withContext');

var _withContext2 = _interopRequireDefault(_withContext);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ssrComponentWithInitialProps(_ref) {
  var Target = _ref.Target,
      context = _ref.context,
      renderProps = _ref.renderProps;

  // get the page with the initialProps
  var pageComponent = renderProps.components[renderProps.components.length - 1];
  // use the getInitialProps from the page to retrieve the props to initialize
  return pageComponent.getInitialProps(context).then(function (initialProps) {
    // create the App component with the context, the initialProps and the Target Component
    var App = (0, _withContext2.default)((0, _extends3.default)({}, context, { initialProps: initialProps }))(Target);
    // render our whole application with the needed props and get the html string
    var reactString = _server2.default.renderToString(_react2.default.createElement(App, (0, _extends3.default)({}, renderProps, { initialProps: initialProps })));
    return { initialProps: initialProps, reactString: reactString };
  });
}